"""
仕事検索サンプルプログラム
# python search_job_json.py 飛行機 研究 ・・・
"""

import sys  # 入出力
import urllib.request # URLアクセス
import urllib.parse # URL生成
import json    # JSON（APIの受け取り形式）


def create_work_info(index, work_node):
#Webサービスからの出力を解析
    return """------ No. {} ------
【職業】 {}
【説明】 {}
【資格】 {}
【学問】 {}""".format(index, # No.
                    work_node["name"], # 職業
                    work_node["desc"], # 説明
                    " ".join([l["name"] for l in work_node["license"]]), # 資格
                    " ".join([s["name"] for s in work_node["subject"]])  # 学問
                    )


def create_result_info(json_result):
#Webサービスからの出力を解析
    return "{}件のお仕事が見つかりました。最初の{}件を表示します。".format(
            json_result["results"]["results_available"], # ~件のお仕事が・・・
            json_result["results"]["results_returned"]   # 最初の~件を・・・
            )


def main():
    # APIを通して、Webサービスを実行
    url = "http://webservice.recruit.co.jp/shingaku/work/v1/?{}".format(
        urllib.parse.urlencode(
            {"key"     : "382312f6b1fe7a",                         # APIキー(このキーはダミー。自分で取得したものを記入。db*3+9)
             "keyword" : " ".join(sys.argv[1:]),   # 入力からクエリを生成
             "format"  : "json"                                    # レスポンス型式をJSONに指定
            }))

    f_url = urllib.request.urlopen(url).read()
    json_result = json.loads(f_url.decode("utf-8"))   # JSON形式の実行結果を格納

    # 出力
    print(create_result_info(json_result))
    for index, work in enumerate(json_result["results"]["work"]): #enumerate → 何ループ目かがindexに格納される
        print(create_work_info(index+1,work))

    return

if __name__ == "__main__":
    main()
